unit AFTableInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Db, DbTables, StdCtrls,extctrls;

type
  TAFTableInfo = class(TComponent)
  private
	 { Private declarations }
	 FDataSet:	TTable;
	 FLabelName:	TLabel;
	 FLabelType:	TLabel;
	 FLabelRecordCount:	TLabel;
	 FLabelRecNo:	TLabel;
	 FLabelDataBaseName:	TLabel;
	 FLabelDir:	TLabel;
	 FLabelState:	TLabel;
	 FLabelIndex:	TLabel;
	 FTimer: TTimer;
	 FAutoUpdate:	Boolean;
	 FStateCaptions: TStrings;
	 FFilteredCaptions: TStrings;
	 FReadOnlyCaptions: TSTrings;
	 FLabelFilter: TLabel;
	 FLabelFiltered: TLabel;
	 FLabelReadOnly: TLabel;
	 procedure SetDataset(Value: TTable);
	 procedure SetLabelName(Value: TLabel);
	 procedure SetLabelDataBaseName(Value:	TLabel);
	 procedure SetLabelDir(Value:	TLabel);
	 procedure SetLabelRecordCount(Value:	TLabel);
	 procedure SetLabelState(Value:	TLabel);
	 procedure SetLabelRecNo(Value:	TLabel);
	 procedure FTimerTimer(sender: TObject);
	 procedure SetAutoUpdate(Value: Boolean);
	 procedure SetLabelType(Value: TLabel);
	 procedure SetLabelIndex(Value: TLabel);
	 procedure SetLabelFilter(Value: TLabel);
	 procedure SetLabelFiltered(Value: Tlabel);
	 procedure SetLabelReadOnly(Value:	TLabel);
	 procedure SetStateCaptions(Value:	TStrings);
	 procedure SetFilteredCaptions(Value:  TStrings);
	 procedure SetReadOnlyCaptions(Value: TStrings);
	 protected
	 { Protected declarations }
  public
	 { Public declarations }
	 constructor Create(AOwner: TComponent); override;
	 destructor Destroy; override;
	 procedure Update;
    property AutoUpdate:	Boolean read FAutoUpdate write SetAutoUpdate;
  published
	 { Published declarations }
	 property Dataset: TTable read FDataset write SetDataset;
	 property LabelName: TLabel read FLabelName write SetLabelName;
	 property LabelDataBaseName: TLabel read FLabelDataBaseName write SetLabelDataBaseName;
	 property LabelDir:	TLabel read FLabelDir write SetLabelDir;
	 property LabelRecordCount:	TLabel read FLabelRecordCount write SetLabelRecordCount;
	 property LabelState: TLabel read FLabelState write SetLabelState;
	 property LabelRecNo: TLabel read FLabelRecNo write SetLabelRecNo;
	 property LabelType: TLabel read FLabelType write SetLabelType;
	 property LabelIndex:	TLabel read FLabelIndex write SetLabelIndex;
	 property LabelFilter:	TLabel read FLabelFilter write SetLabelFilter;
	 property LabelFiltered: TLabel read FLabelFiltered write SetLabelFiltered;
	 property LabelReadOnly:	TLabel read FLabelReadOnly write SetLabelReadOnly;
	 property StateCaptions:	TStrings read FStateCaptions write SetStateCaptions;
	 property ReadOnlyCaptions:	TStrings read FReadOnlyCaptions write SetReadOnlyCaptions;
	 property FilteredCaptions:   TStrings read FFilteredCaptions write SetFilteredCaptions; 
  end;

procedure Register;

implementation
const
{$IFDEF VER100}
	TheType:	array[ttDefault..ttASCII] of String = ('Default','Paradox','DBase','ASCII');
{$ELSE}
	TheType:	array[ttDefault..ttASCII] of String = ('Default','Paradox','DBase','FoxPro','ASCII');
{$ENDIF}
	AfStateStrings:	array[dsInactive..dsCurValue] of String = ('Inactive','Browse','Edit','Insert','SetKey','CalcFields','Filter','NewValue','OldValue','CurValue');
	MyState:	array[dsInactive..dsCurValue] of Integer = (0,1,2,3,4,5,6,7,8,9);
	MyValues:   Array[False..True] of String = ('False','True');
	MyCount: Array[False..True] of Integer = (0,1);
		
procedure Register;
begin
  RegisterComponents('AF', [TAFTableInfo]);
end;
procedure TAfTableInfo.SetDataset(Value: TTable);
begin
	if FDataset <> Value then
		FDataset := Value;
end;
procedure TAfTableInfo.SetLabelName(Value: TLabel);
begin
	if FLabelName <> Value then
		FLabelName := Value;
end;
procedure TAfTableInfo.SetLabelDir(Value: TLabel);
begin
	if FLabelDir <> Value then
		FLabelDir := Value;
end;
procedure TAfTableInfo.SetLabelDataBaseName(Value: TLabel);
begin
	if FLabelDataBaseName <> Value then
		FLabelDataBaseName := Value;
end;
procedure TAfTableInfo.SetLabelRecordCount(Value: TLabel);
begin
	If FLabelRecordCount <> Value then
		FLabelRecordCount := Value;
end;
constructor TAFTableInfo.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);
	FTimer := TTimer.Create(Self);
	FTimer.Interval := 100;
	FTimer.ontimer := FTimerTimer;
   fTimer.Enabled := False;
	FAutoUpdate := False;
	FStateCaptions := TStringList.Create;
	FFilteredCaptions := TStringList.Create;
	FReadOnlyCaptions := TStringList.Create;
	Update;
end;
destructor TAFTableInfo.Destroy;
begin
FTimer.Free;
FStateCaptions.Free;
FFilteredCaptions.Free;
FReadOnlyCaptions.Free;
inherited Destroy;
end;
procedure TAfTableInfo.Update;
	Function GetDir:String;
		var
		MyList: TStringList;
		begin
			MyList := TStringList.Create;
			Session.GetAliasParams(FDataSet.DataBaseName,MyList);
			Result := MyList.Values['PATH'];
			MyList.Free;
		end;
	Function GetRecordCount: String;  
		var
		MyTable: TTable;
		begin
			MyTable := TTable.Create(Self);
			MyTable.DatabaseName := FDataset.DatabaseName;
			MyTable.TableName := FDataset.TableName;
			MyTable.Filter := FDataSet.Filter;
			MyTable.Filtered := FDataSet.Filtered;
			MyTable.Open;
			result := IntToStr(MyTable.RecordCount);
			MyTable.Close;
		end;
	Function GetState: String;
	begin
		If FStateCaptions.Count > 0 then
			If FStateCaptions[MyState[fdataset.state]] <> '' then
				result := FStateCaptions[MyState[fdataset.state]]
			else
				result := AFStateStrings[fdataset.state]
		else
			result := AFStateStrings[fdataset.state];
	end;
	Function GetType: String;
	begin
		result := TheType[fDataset.tabletype];
	end;
   Function GetFiltered:String;
	begin
		If FFilteredCaptions.Count > 0 then
			If FFilteredCaptions[MyCount[fdataset.Filtered]] <> '' then
				result := FFilteredCaptions[MyCount[fdataset.Filtered]]
			else
				result := MyValues[fdataset.Filtered]
		else
			result := MyValues[fdataset.Filtered];
		end;
	function GetReadOnly: String;
	begin
		If FReadOnlyCaptions.Count > 0 then
			If FReadOnlyCaptions[MyCount[fdataset.ReadOnly]] <> '' then
				result := FReadOnlyCaptions[MyCount[fdataset.ReadOnly]]
			else
				result := MyValues[fdataset.ReadOnly]
		else
			result := MyValues[fdataset.ReadOnly];
	end;
begin
	If FDataset <> nil then
	begin
		If FLabelName <> nil then
      try
			FLabelName.Caption := FDataset.TableName;
      except
         FLabelName := nil;
      end;
		If FLabelDataBaseName <> nil then
      try
			FLabelDataBaseName.Caption := FDataset.DataBaseName;
      except
      	FLabelDataBaseName := nil; 
      end;  
      If FLabelDir <> nil then
      try
			FLabelDir.Caption := GetDir;
      except
         FLabelDir := nil;
      end;
		If FLabelRecordCount <> nil then
      try
			FLabelRecordCount.Caption := GetRecordCount;
      except
         FLabelRecordCount := nil;
      end;
		If FLabelState <> nil then
      try
			FLabelState.Caption := GetState;
      except
         FLabelState := nil;
      end;
		If FLabelRecNo <> nil then
      try
			If FDataset.Active then
			FLabelRecNo.Caption := IntToStr(FDataset.Recno)
			else
			FLabelRecNo.Caption := '';
      except
         FLabelRecNo := nil;
      end;
		If FLabelType <> nil then
      try
			FLabelType.Caption := GetType;
      except
         FLabelType := nil;
      end;
		If FLabelIndex <> nil then
      try
			FLabelIndex.Caption := FDataset.IndexName;
      except
         FLabelIndex := nil;
      end;
		If FLabelFilter <> nil then
      try
			FLabelFilter.Caption := FDataset.Filter;
      except
         FLabelFilter := nil;
      end;
      If FLabelFiltered <> nil then
      try
         FLabelFiltered.Caption := GetFiltered;
      except
         FLabelFiltered := nil;
		end;
		If FLabelReadOnly <> nil then
		try
			FLabelReadOnly.Caption := GetReadOnly;
		except
			FLabelReadOnly := nil;
		end;
	end;
end;
procedure TAfTableInfo.FTimerTimer;
begin
	Update;
	Application.ProcessMessages;
end;
procedure TAfTableInfo.SetLabelState(Value:	TLabel);
begin
	If FLabelState <> value then
		FLabelState := Value;
end;
procedure TAfTableInfo.SetLabelRecNo(Value:	TLabel);
begin
	If FLabelRecNo <> value then
		FLabelRecNo := Value;
end;
procedure TAFTableInfo.SetAutoUpdate(Value:	Boolean);
begin
	If FAutoUpdate <> Value then FAutoUpdate := Value;
	FTimer.Enabled := Value;
end;
procedure TAFTableInfo.SetLabelType(Value: TLabel);
begin
	If FLabelType <> value then
		FLabelType := value;
end;
procedure TAFTableInfo.SetStateCaptions(Value: TStrings);
begin
	If (Value.Count <> 10) and (Value.Count <> 0) then
		begin
			ShowMessage('Lines for State Captions must be 10 or 0!');
         exit;
      end;
	FStateCaptions.Assign(Value);
end;
procedure TAFTableInfo.SetFilteredCaptions(Value: TStrings);
begin
	If (Value.Count <> 2) and (Value.Count <> 0) then
		begin
			ShowMessage('Lines for Filtered Captions must be 2 or 0!');
			exit;
      end;
	FFilteredCaptions.Assign(Value);
end;
procedure TAFTableInfo.SetReadOnlyCaptions(Value: TStrings);
begin
	If (Value.Count <> 2) and (Value.Count <> 0) then
		begin
			ShowMessage('Lines for ReadOnly Captions must be 2 or 0!');
			exit;
      end;
	FReadOnlyCaptions.Assign(Value);
end;
procedure TAFTableInfo.SetLabelIndex(Value: TLabel);
begin
	If FLabelIndex <> Value then
		FLabelIndex := Value;
end;
procedure TAFTableInfo.SetLabelFilter(Value: TLabel);
begin
	If FLabelFilter <> Value then
		FLabelFilter := Value;
end;
procedure TAFTableInfo.SetLabelFiltered(Value: TLabel);
begin
	If FLabelFiltered <> Value then
		FLabelFiltered := Value;
end;
procedure TAFTableInfo.SetLabelReadOnly(Value: TLabel);
begin
	If FLabelReadOnly <> Value then
		FLabelReadOnly := Value;
end;
end.
