unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, IBEAntialiasButton, StdCtrls, ComCtrls, Spin, ExtCtrls,
  ShellAPI;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    IBEAntialiasButton1: TIBEAntialiasButton;
    IBEAntialiasButton2: TIBEAntialiasButton;
    IBEAntialiasButton3: TIBEAntialiasButton;
    IBEAntialiasButton6: TIBEAntialiasButton;
    IBEAntialiasButton5: TIBEAntialiasButton;
    IBEAntialiasButton4: TIBEAntialiasButton;
    IBEAntialiasButton9: TIBEAntialiasButton;
    IBEAntialiasButton8: TIBEAntialiasButton;
    IBEAntialiasButton7: TIBEAntialiasButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    ButtonNo1: TIBEAntialiasButton;
    ButtonNo2: TIBEAntialiasButton;
    ButtonNo3: TIBEAntialiasButton;
    StatusBar: TStatusBar;
    combo_BtnNumber: TComboBox;
    Label4: TLabel;
    chk_enabled: TCheckBox;
    Label5: TLabel;
    spin_BorderSize: TSpinEdit;
    chk_antialias: TCheckBox;
    spin_BorderRound: TSpinEdit;
    Label6: TLabel;
    combo_alignment: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    spin_separation: TSpinEdit;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    spin_left: TSpinEdit;
    Label10: TLabel;
    spin_top: TSpinEdit;
    spin_bottom: TSpinEdit;
    Label11: TLabel;
    Label12: TLabel;
    spin_right: TSpinEdit;
    GroupBox4: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    ColorDialog: TColorDialog;
    FontDialog: TFontDialog;
    GroupBox5: TGroupBox;
    IBEAntialiasButton10: TIBEAntialiasButton;
    IBEAntialiasButton11: TIBEAntialiasButton;
    IBEAntialiasButton12: TIBEAntialiasButton;
    IBEAntialiasButton13: TIBEAntialiasButton;
    IBEAntialiasButton14: TIBEAntialiasButton;
    GroupBox6: TGroupBox;
    Label17: TLabel;
    Label18: TLabel;
    procedure FormShow(Sender: TObject);
    procedure chk_enabledClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure combo_BtnNumberChange(Sender: TObject);
    procedure IBEAntialiasButton1MouseEnter(Sender: TObject);
    procedure IBEAntialiasButton1MouseLeave(Sender: TObject);
    procedure IBEAntialiasButton1Click(Sender: TObject);
    procedure IBEAntialiasButton1DblClick(Sender: TObject);
    procedure Label18Click(Sender: TObject);
  private
    Updating : Boolean;
    procedure UpdateButtons;
    procedure UpdateColor(Kind: Integer; AColor: TColor; IsBorder: Boolean);
    procedure UpdateFont(Kind: Integer; AFont: TFont);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.UpdateButtons;
var Btn: TIBEAntialiasButton;
begin
 if Updating then exit;
 case combo_BtnNumber.ItemIndex of
  0: Btn := ButtonNo1;
  1: Btn := ButtonNo2;
  else Btn := ButtonNo3;
 end;
 with Btn do
 begin
  Enabled := chk_enabled.Checked;
  case chk_antialias.Checked of
   True: AntialiasMode := AMShape;
   False: AntialiasMode := AMNone;
  end;
  BorderSize := spin_BorderSize.Value;
  BorderRound := spin_BorderRound.Value;
  case combo_Alignment.ItemIndex of
   0: Alignment := taLeftJustify;
   1: Alignment := taCenter;
   2: Alignment := taRightJustify;
  end;
  GlyphSeparation := spin_separation.Value;
  with Margins do
  begin
   Left := spin_left.Value;
   Top := spin_top.Value;
   Right := spin_right.Value;
   Bottom := spin_bottom.Value;
  end;
 end;
end;

procedure TForm1.UpdateColor(Kind: Integer; AColor: TColor; IsBorder: Boolean);
var Btn: TIBEAntialiasButton;
begin
 case combo_BtnNumber.ItemIndex of
  0: Btn := ButtonNo1;
  1: Btn := ButtonNo2;
  else Btn := ButtonNo3;
 end;
 with Btn.Properties do
 begin
  case Kind of
   0: if IsBorder then Btn.Properties.Disabled.Border := AColor else Btn.Properties.Disabled.Color := AColor;
   2: if IsBorder then MouseDown.Border := AColor else MouseDown.Color := AColor;
   3: if IsBorder then MouseUp.Border := AColor else MouseUp.Color := AColor;
   else begin
    if IsBorder then MouseAway.Border := AColor else MouseAway.Color := AColor;
   end;
  end;
 end;
end;

procedure TForm1.UpdateFont(Kind: Integer; AFont: TFont);
var Btn: TIBEAntialiasButton;
begin
 case combo_BtnNumber.ItemIndex of
  0: Btn := ButtonNo1;
  1: Btn := ButtonNo2;
  else Btn := ButtonNo3;
 end;
 with Btn.Properties do
 begin
  case Kind of
   0: Btn.Properties.Disabled.Font := AFont;
   2: MouseDown.Font := AFont;
   3: MouseUp.Font := AFont;
   else MouseAway.Font := AFont;
  end;
 end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 combo_BtnNumber.ItemIndex := 0;
 combo_alignment.ItemIndex := 0;
end;

procedure TForm1.chk_enabledClick(Sender: TObject);
begin
 UpdateButtons;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if not (Sender is TButton) then exit;
 if ColorDialog.Execute then UpdateColor(TButton(Sender).Tag, ColorDialog.Color, true);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if not (Sender is TButton) then exit;
 if ColorDialog.Execute then UpdateColor(TButton(Sender).Tag, ColorDialog.Color, false);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 if not (Sender is TButton) then exit;
 if FontDialog.Execute then UpdateFont(TButton(Sender).Tag, FontDialog.Font);
end;

procedure TForm1.combo_BtnNumberChange(Sender: TObject);
var Btn: TIBEAntialiasButton;
begin
 Updating := True;
 case combo_BtnNumber.ItemIndex of
  0: Btn := ButtonNo1;
  1: Btn := ButtonNo2;
  else Btn := ButtonNo3;
 end;
 with Btn do
 begin
  chk_enabled.Checked := enabled;
  chk_antialias.Checked := (AntialiasMode = AMShape);
  spin_BorderSize.Value := BorderSize;
  spin_BorderRound.Value := BorderRound;
  case Alignment of
   taLeftJustify: combo_Alignment.ItemIndex := 0;
   taCenter: combo_Alignment.ItemIndex := 1;
   taRightJustify: combo_Alignment.ItemIndex := 2;
  end;
  spin_separation.Value := GlyphSeparation;
  spin_Left.Value := Margins.Left;
  spin_Top.Value := Margins.Top;
  spin_Right.Value := Margins.Right;
  spin_Bottom.Value := Margins.Bottom;
 end;
 Updating := False;
end;

procedure TForm1.IBEAntialiasButton1MouseEnter(Sender: TObject);
begin
 with (Sender as TControl) do
  StatusBar.SimpleText := 'Mouse enter - ' + Name;
end;

procedure TForm1.IBEAntialiasButton1MouseLeave(Sender: TObject);
begin
 with (Sender as TControl) do
  StatusBar.SimpleText := 'Mouse leave - ' + Name;
end;

procedure TForm1.IBEAntialiasButton1Click(Sender: TObject);
begin
 with (Sender as TControl) do
  StatusBar.SimpleText := 'Click - ' + Name;
end;

procedure TForm1.IBEAntialiasButton1DblClick(Sender: TObject);
begin
 with (Sender as TControl) do
  StatusBar.SimpleText := 'Double click - ' + Name;
end;

procedure TForm1.Label18Click(Sender: TObject);
begin
 ShellExecute(0, 'open', PChar('http://IBESoftware.free.fr'), nil, nil, SW_SHOWNORMAL);
end;

end.

